local love_timer_sleep = love.timer.sleep -- in s (like >= 0.8.0)
if love._version:find("^0%.[0-7]%.") then -- if version < 0.8.0
   love_timer_sleep = function(s) love.timer.sleep(s * 1000) end
end

function love.load()
	min_dt = 1 / 60
	next_time = love.timer.getMicroTime()
	grass = love.graphics.newImage("grass.png")
	batch = love.graphics.newSpriteBatch(grass, 20 * 30)
	for x = 0, 29 do
	   for y = 0, 19 do
		  batch:add(x * 32, y * 32)
	   end
	end
	gr = love.graphics
	mo = love.mouse
	getW = gr.getWidth()
	getH = gr.getHeight()
	grid = 32
end

function love.draw()
	gr.setColor(255, 255, 255, 255)
	love.graphics.draw(batch)
	draw_grid()
	local gx, gy = getTile()
	draw_hover(gx, gy)
	gr.setColor(255, 255, 255, 255)
	love.graphics.print("Current FPS: " .. tostring(love.timer.getFPS()), 10, 10)
	local cur_time = love.timer.getMicroTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love_timer_sleep(next_time - cur_time)
end

function draw_grid()
	gr.setColor(128, 128, 128, 128)
	for x = 0, getW, grid do
		gr.line(x, 0, x, getH)
	end
	for y = 0, getH, grid do
		gr.line(0, y, getW, y)
	end
end

function draw_hover(gx, gy)
	gr.setColor(0, 0, 0, 32)
	gr.rectangle("fill", gx * grid, gy * grid, grid, grid)
end

function getTile()
	local mx, my = mo.getPosition()
	return math.floor(mx / grid), math.floor(my / grid)
end

function love.update(dt)
	next_time = next_time + min_dt
end